﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Reactive.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ReactiveTest
{
    public partial class Form1 : Form
    {
        private IDisposable subscription;

        public Form1()
        {
            InitializeComponent();
            subscription = Observable.FromEventPattern<MouseEventArgs>(this, "MouseMove")
                .Select(e => new Point(e.EventArgs.X, e.EventArgs.Y))
                .Throttle(TimeSpan.FromMilliseconds(200))
                .DistinctUntilChanged()
                .ObserveOn(SynchronizationContext.Current)
                .Subscribe(p => {
                    listBox1.Items.Add(string.Format("Got X={0} Y={1}", p.X, p.Y));
                    Thread.Sleep(1000);
                });
        }

        private void button1_Click(object sender, EventArgs e)
        {
            subscription.Dispose();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            textBox1.Text = DateTime.Now.ToString("HH:mm:ss,ff");
        }	
    }
}
